// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Լ 
int putchar_0(char data);					// COM1 ۽
int getchar_0(void);						// COM1 

//  
char com1_rx_data,com1_rx_eflg = 0;				//   ͷƮ  /÷

int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
int exint1_flg = 0;						// EXINT1 ͷƮ  ÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// Crystal Oscillator division factor: 1
        CLKPR=0x80;
        CLKPR=0x00;

// PortA 
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)

// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg             
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	TCCR0A=0x00;
	TCCR0B=0x00;
	TCNT0=0x00;
	OCR0A=0x00;
	OCR0B=0x00;

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	ICR1H=0x00;
	ICR1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
	GIMSK=0x00;
	MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK=0x00;

//  ʱȭ
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSRA=0x00;
	UCSRB=0x98;
	UCSRC=0x06;
	UBRRH=0x00;
	UBRRL=0x26;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
	USICR=0x00;

// Analog Comparator initialization
	ACSR=0x80;
	
//	fdevopen(putchar_0,getchar_0,0);			// printf()

// Global enable interrupts
	sei();
}

// ================================  ͷƮ =============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_USART0_RECV)
{
char status,data;

	status = UCSRA;
	data = UDR;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}
}

// ========================== ܺ INT0 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT0)
{
	exint0_flg = 1;						// EXINT0 ÷ ON
}

// ========================== ܺ INT1 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT1)
{
	exint1_flg = 1;						// EXINT1 ÷ ON
}

// ============================== COM1 Ʈ ۽ ==========================
// [μ] char sbuf[]
// item1:   
// --------------------------------------------------------------------------
void com_puts(char sbuf[])
{
char ch;
int i = 0;

	ch = sbuf[i++];						//  
	while(ch != 0){
		putchar_0(ch);					// 1Ʈ ۽
		ch = sbuf[i++];						//  
	}
}

// ============================== COM1 1Ʈ ۽ =========================
// [μ] char data
// item1:  
// --------------------------------------------------------------------------
int putchar_0(char data)
{
	if(data == '\n'){
		while((UCSRA & DATA_REGISTER_EMPTY) == 0);
		UDR = '\r';
	}
	while((UCSRA & DATA_REGISTER_EMPTY) == 0);
	UDR = data;
	return(0);
}

// ============================== COM1 1Ʈ  =========================
// [μ] void
// []  
// --------------------------------------------------------------------------
int getchar_0(void)
{
	while((UCSRA & RX_COMPLETE) == 0);
	return(UDR);
}

