// ========================== ATTINY2313V CPU ׽Ʈ α׷ =================
//  CPU : ATTINY2313V-12M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR
//      : serial 19200,N,8,1
//            I/O ͷƮ ׽Ʈ
// ----------------------------------------------------------------------------
// ⺻ 
#include <tiny2313.h>						// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

//  
char com1_rx_data,com1_rx_eflg = 0;				//   ͷƮ  /÷

int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
int exint1_flg = 0;						// EXINT1 ͷƮ  ÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// Crystal Oscillator division factor: 1
        CLKPR=0x80;
        CLKPR=0x00;
// PortA 
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)

// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	TCCR0A=0x00;
	TCCR0B=0x00;
	TCNT0=0x00;
	OCR0A=0x00;
	OCR0B=0x00;

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	ICR1H=0x00;
	ICR1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
	GIMSK=0x00;
	MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK=0x00;

//  ʱȭ
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSRA=0x00;
	UCSRB=0x98;
	UCSRC=0x06;
	UBRRH=0x00;
	UBRRL=0x26;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
	USICR=0x00;

// Analog Comparator initialization
	ACSR=0x80;

// Global enable interrupts
#asm("sei")
}

// ================================  ͷƮ =============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [USART_RXC] void uart_rx_isr(void)
{
char status,data;

	status=UCSRA;
	data=UDR;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

}

// ========================== ܺ INT0 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT0] void ext_int0_isr(void)
{
	exint0_flg = 1;						// EXINT0 ÷ ON
}

// ========================== ܺ INT1 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT1] void ext_int1_isr(void)
{
	exint1_flg = 1;						// EXINT1 ÷ ON
}

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void exint_test(void);						// EXINT0,1 TEST

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
void main(void)
{
	cpu_setup();						// cpuʱȭ
	main_menu_disp();					//  ޴ ǥ
	while(1){						// Place your code here
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '1') exint_test();  	// EXINT0,1 TEST
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
}

// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("=================== MAIN MENU ==================\r\n");
	printf("- 1  : EXINT0,1 TEST                            \r\n");
	printf("----------------- CPUPLAZA ---------------------\r\n");
}

// ============================== EXINT0,1 TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void exint_test(void)
{
int exit_flg = 0;

	printf("============== EXINT0,1 TEST ==========\r\n");
	printf("- 0  : TOP menu                        \r\n");
	printf("- interrupt : INT0 Falling Edge        \r\n");
	printf("-             INT1 Falling Edge        \r\n");
	printf("---------------------------------------\r\n");

// External Interrupt(s) 
// INT0 Mode: Falling Edge
// INT1 Mode: Falling Edge
	GIMSK = 0xC0;
	MCUCR = 0x0A;
	EIFR  = 0xC0;

        PORTD |= 0x0c;                                          // INT0,1 PULL UP

	exint0_flg = exint1_flg = 0;				// EXINT0,1 ͷƮ ÷ Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
			printf("EXINT0 Interrupt\r\n");
			exint0_flg = 0;
		}
		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
			printf("EXINT1 Interrupt\r\n");
			exint1_flg = 0;
		}
	}

// External Interrupt(s) 
	GIMSK &= 0x3f;
	MCUCR = 0x00;
	EIFR  = 0x00;

        PORTD &= 0xf3;                                          // INT0,1 Ʈ ʱġ

	main_menu_disp();					//  ޴ ǥ
}
