
;CodeVisionAVR C Compiler V1.25.3 Standard
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny2313V
;Clock frequency        : 12.000000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 64 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313V
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "test.vec"
	.INCLUDE "test.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xA0)
	LDI  R29,HIGH(0xA0)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0xA0
;       1 // ========================== ATTINY2313V CPU ׽Ʈ α׷ =================
;       2 //  CPU : ATTINY2313V-12M
;       3 //     ¥ : 2006-
;       4 //      : Ver1.0
;       5 //    : www.cpuplaza.com
;       6 // Ϸ : CodeVisionAVR
;       7 //      : serial 19200,N,8,1
;       8 //            I/O/TIMER0 ׽Ʈ
;       9 // ----------------------------------------------------------------------------
;      10 // ⺻ 
;      11 #include <tiny2313.h>						// CPU  
;      12 
;      13 #include <stdio.h>
;      14 #include <stdlib.h>
;      15 #include <ctype.h>
;      16 #include <float.h>
;      17 
;      18 //  
;      19 #include "cpusetup.inc"						// cpu  ͷƮ  ƾ
;      20 // =================================== CPUʱȭ ͷƮ ===================
;      21 //      : CPU  ϰ ͷƮ  ƾ .
;      22 // ----------------------------------------------------------------------------
;      23 //   
;      24 #define RXB8 1
;      25 #define TXB8 0
;      26 #define UPE 2
;      27 #define OVR 3
;      28 #define FE 4
;      29 #define UDRE 5
;      30 #define RXC 7
;      31 
;      32 #define FRAMING_ERROR (1<<FE)
;      33 #define PARITY_ERROR (1<<UPE)
;      34 #define DATA_OVERRUN (1<<OVR)
;      35 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      36 #define RX_COMPLETE (1<<RXC)
;      37 
;      38 //  
;      39 char com1_rx_data,com1_rx_eflg = 0;				//   ͷƮ  /÷
;      40 
;      41 int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī
;      42 
;      43 // ===================================== CPUʱȭ ============================
;      44 // [μ] void
;      45 // ----------------------------------------------------------------------------
;      46 void cpu_setup(void)
;      47 {

	.CSEG
_cpu_setup:
;      48 // Crystal Oscillator division factor: 1
;      49         CLKPR=0x80;
	LDI  R30,LOW(128)
	OUT  0x26,R30
;      50         CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
;      51 // PortA 
;      52 	PORTA=0x00;						// Ʈ  reg
	OUT  0x1B,R30
;      53 	DDRA=0x00;						// Ʈ  reg(0Է,1)
	OUT  0x1A,R30
;      54 
;      55 // PortB 
;      56 	PORTB=0x00;						// Ʈ  reg
	RCALL SUBOPT_0x0
;      57 	DDRB=0x00;						// Ʈ  reg(0Է,1)
;      58 
;      59 // PortD 
;      60 	PORTD=0x00;						// Ʈ  reg
;      61 	DDRD=0x00;                                              // Ʈ  reg(0Է,1)
;      62 
;      63 // Timer/Counter0 
;      64 	TCCR0A=0x00;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1
;      65 	TCCR0B=0x00;
;      66 	TCNT0=0x00;
;      67 	OCR0A=0x00;
;      68 	OCR0B=0x00;
;      69 
;      70 // Timer/Counter1 
;      71 	TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
;      72 	TCCR1B=0x00;
	OUT  0x2E,R30
;      73 	TCNT1H=0x00;
	OUT  0x2D,R30
;      74 	TCNT1L=0x00;
	OUT  0x2C,R30
;      75 	ICR1H=0x00;
	OUT  0x25,R30
;      76 	ICR1L=0x00;
	OUT  0x24,R30
;      77 	OCR1AH=0x00;
	OUT  0x2B,R30
;      78 	OCR1AL=0x00;
	OUT  0x2A,R30
;      79 	OCR1BH=0x00;
	OUT  0x29,R30
;      80 	OCR1BL=0x00;
	OUT  0x28,R30
;      81 
;      82 // External Interrupt(s) 
;      83 // INT0: Off
;      84 // INT1: Off
;      85 	GIMSK=0x00;
	OUT  0x3B,R30
;      86 	MCUCR=0x00;
	OUT  0x35,R30
;      87 
;      88 // Timer(s)/Counter(s) Interrupt(s) 
;      89 	TIMSK=0x00;
	OUT  0x39,R30
;      90 
;      91 //  ʱȭ
;      92 // 19200Bps, 8Data, 1 Stop, No Parity
;      93 	UCSRA=0x00;
	OUT  0xB,R30
;      94 	UCSRB=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;      95 	UCSRC=0x06;
	LDI  R30,LOW(6)
	OUT  0x3,R30
;      96 	UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x2,R30
;      97 	UBRRL=0x26;
	LDI  R30,LOW(38)
	OUT  0x9,R30
;      98 
;      99 // Universal Serial Interface initialization
;     100 // Mode: Disabled
;     101 // Clock source: Register & Counter=no clk.
;     102 // USI Counter Overflow Interrupt: Off
;     103 	USICR=0x00;
	LDI  R30,LOW(0)
	OUT  0xD,R30
;     104 
;     105 // Analog Comparator initialization
;     106 	ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     107 
;     108 // Global enable interrupts
;     109 #asm("sei")
	sei
;     110 }
	RET
;     111 
;     112 // ================================  ͷƮ =============================
;     113 // [μ] void
;     114 // ----------------------------------------------------------------------------
;     115 interrupt [USART_RXC] void uart_rx_isr(void)
;     116 {
_uart_rx_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;     117 char status,data;
;     118 
;     119 	status=UCSRA;
	RCALL __SAVELOCR2
;	status -> R17
;	data -> R16
	IN   R17,11
;     120 	data=UDR;
	IN   R16,12
;     121 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;     122 		com1_rx_data = data;
	MOV  R3,R16
;     123 		com1_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R2,R30
;     124 	}
;     125 
;     126 }
_0x3:
	RCALL __LOADLOCR2P
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;     127 
;     128 // ========================== TIMER0 overflow ͷƮ ========================
;     129 // [μ] void
;     130 // [] 12,000,000 / 1024 / 117 =  1 / 100.1602564 = 9.9984ms
;     131 // ----------------------------------------------------------------------------
;     132 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     133 {
_timer0_ovf_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     134 	TCNT0 = 138;						// 255-117 = 138
	LDI  R30,LOW(138)
	OUT  0x32,R30
;     135 	timer0_cnt++;						// Ÿ̸0 ī
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
;     136 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     137 
;     138 // Լ 
;     139 void main_menu_disp(void);					//  ޴ ǥ
;     140 void cpu_ioport_output(void);					// CPU PORT I/O ׽Ʈ
;     141 
;     142 //  
;     143 
;     144 // ===============================  α׷ ==============================
;     145 // [μ]: void
;     146 // ---------------------------------------------------------------------------
;     147 void main(void)
;     148 {
_main:
;     149 	cpu_setup();						// cpuʱȭ
	RCALL _cpu_setup
;     150 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     151 	while(1){						// Place your code here
_0x4:
;     152 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x7
;     153 			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
	LDI  R30,LOW(49)
	CP   R30,R3
	BRNE _0x8
	RCALL _cpu_ioport_output
;     154 			else putchar(com1_rx_data);
	RJMP _0x9
_0x8:
	ST   -Y,R3
	RCALL _putchar
;     155 			com1_rx_eflg = 0;
_0x9:
	CLR  R2
;     156 		}
;     157 	}
_0x7:
	RJMP _0x4
;     158 }
_0xA:
	RJMP _0xA
;     159 
;     160 // =====================================  ޴ ǥ =======================
;     161 // [μ]: void
;     162 // ---------------------------------------------------------------------------
;     163 void main_menu_disp(void)
;     164 {
_main_menu_disp:
;     165 	printf("\r\n");
	__POINTW1FN _0,0
	RCALL SUBOPT_0x2
;     166 	printf("=================== MAIN MENU ==================\r\n");
	__POINTW1FN _0,3
	RCALL SUBOPT_0x2
;     167 	printf("- 1  : CPU I/O PORT TEST                        \r\n");
	__POINTW1FN _0,54
	RCALL SUBOPT_0x2
;     168 	printf("----------------- CPUPLAZA ---------------------\r\n");
	__POINTW1FN _0,105
	RCALL SUBOPT_0x2
;     169 }
	RET
;     170 
;     171 // ============================= IO PORT TEST =================================
;     172 // [μ]: void
;     173 // ----------------------------------------------------------------------------
;     174 void cpu_ioport_output(void)
;     175 {
_cpu_ioport_output:
;     176 int out_cnt,exit_flg = 0;
;     177 
;     178 	printf("================ CPU I/O PORT TEST ==============\r\n");
	RCALL __SAVELOCR4
;	out_cnt -> R16,R17
;	exit_flg -> R18,R19
	LDI  R18,0
	LDI  R19,0
	__POINTW1FN _0,156
	RCALL SUBOPT_0x2
;     179 	printf("- 0  : TOP menu                                  \r\n");
	__POINTW1FN _0,208
	RCALL SUBOPT_0x2
;     180 	printf("-------------------------------------------------\r\n");
	__POINTW1FN _0,260
	RCALL SUBOPT_0x2
;     181 // CPU PORT   
;     182 // PORTB[0..7] : OUT
;     183 	PORTB=0xff;						// Ʈ  reg
	LDI  R30,LOW(255)
	OUT  0x18,R30
;     184 	DDRB=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x17,R30
;     185 // PORTD[0..7] : OUT
;     186 	PORTD=0xfc;						// Ʈ  reg
	LDI  R30,LOW(252)
	OUT  0x12,R30
;     187 	DDRD=0xfc;						// Ʈ  reg(0Է,1)
	OUT  0x11,R30
;     188 
;     189 // LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
;     190 	TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     191 	TCCR0B = 0x05;						// system clock,16,000,000 / 1024 = 11.719Khz
	LDI  R30,LOW(5)
	OUT  0x33,R30
;     192 	TCNT0 = 138;						// 255-156 = 99
	LDI  R30,LOW(138)
	OUT  0x32,R30
;     193 	OCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x36,R30
;     194 	OCR0B=0x00;
	OUT  0x3C,R30
;     195 	TIMSK |= 0x02;						// TIMER0 ͷƮ 㰡
	IN   R30,0x39
	ORI  R30,2
	OUT  0x39,R30
;     196 
;     197 	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	CLR  R4
	CLR  R5
;     198 	out_cnt = 0;
	__GETWRN 16,17,0
;     199 	com1_rx_eflg = 0;
	CLR  R2
;     200 	while(exit_flg == 0){
_0xB:
	MOV  R0,R18
	OR   R0,R19
	BREQ PC+2
	RJMP _0xD
;     201 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0xE
;     202 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0xF
	__GETWRN 18,19,1
;     203 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x10
_0xF:
	ST   -Y,R3
	RCALL _putchar
;     204 			com1_rx_eflg = 0;
_0x10:
	CLR  R2
;     205 		}
;     206 		if(timer0_cnt >= 50){				// 500ms  
_0xE:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CP   R4,R30
	CPC  R5,R31
	BRLT _0x11
;     207 			if(out_cnt >= 0 && out_cnt <= 7) PORTB = ~(1 << out_cnt);// PORTB (ش Ʈ 0)
	SUBI R16,0
	SBCI R17,0
	BRLT _0x13
	__CPWRN 16,17,8
	BRLT _0x14
_0x13:
	RJMP _0x12
_0x14:
	MOVW R30,R16
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	RCALL __LSLW12
	COM  R30
	COM  R31
	OUT  0x18,R30
;     208 			else if(out_cnt >= 8 && out_cnt <= 11){	// PORTD 
	RJMP _0x15
_0x12:
	__CPWRN 16,17,8
	BRLT _0x17
	__CPWRN 16,17,12
	BRLT _0x18
_0x17:
	RJMP _0x16
_0x18:
;     209 				if(out_cnt == 8) PORTB = 0xff;	// PORTB CLEAR
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x19
	LDI  R30,LOW(255)
	OUT  0x18,R30
;     210 				PORTD = ~(4 << (out_cnt-8));	// PORTD (ش Ʈ 0)
_0x19:
	MOVW R30,R16
	SBIW R30,8
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	RCALL __LSLW12
	COM  R30
	COM  R31
	OUT  0x12,R30
;     211 			}
;     212 			out_cnt++;				//  ġ ī 
_0x16:
_0x15:
	__ADDWRN 16,17,1
;     213 			if(out_cnt >= 15) out_cnt = 0;		//  ġ ʰ ˻
	__CPWRN 16,17,15
	BRLT _0x1A
	__GETWRN 16,17,0
;     214 			if(out_cnt == 0){			//  ü ʱȭ
_0x1A:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x1B
;     215 				PORTB = 0xff;
	LDI  R30,LOW(255)
	OUT  0x18,R30
;     216 				PORTD = 0xff;
	OUT  0x12,R30
;     217 			}
;     218 			timer0_cnt = 0;
_0x1B:
	CLR  R4
	CLR  R5
;     219 		}
;     220 	}
_0x11:
	RJMP _0xB
_0xD:
;     221 
;     222 // Timer/Counter0 
;     223 	TCCR0A=0x00;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1
;     224 	TCCR0B = 0x00;						// system clock,16,000,000 / 1024 = 11.719Khz
;     225 	TCNT0 = 0;						// 255-156 = 99
;     226 	OCR0A=0x00;
;     227 	OCR0B=0x00;
;     228 	TIMSK &= 0xfd;						// TIMER0 ͷƮ 
	IN   R30,0x39
	ANDI R30,0xFD
	OUT  0x39,R30
;     229 
;     230 // CPU PORT ʱⰪ  
;     231 // PORTB
;     232 	PORTB=0x00;						// Ʈ  reg
	RCALL SUBOPT_0x0
;     233 	DDRB=0x00;						// Ʈ  reg(0Է,1)
;     234 // PORTD
;     235 	PORTD=0x00;						// Ʈ  reg
;     236 	DDRD=0x00;						// Ʈ  reg(0Է,1)
;     237 
;     238 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     239 }
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
;     240 

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	LDD  R26,Y+2
	LD   R30,X
	CPI  R30,0
	BREQ _0x1C
	LDD  R26,Y+1
	LD   R30,X
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x1E
	CPI  R17,2
	BRLO _0x1F
	SUBI R17,LOW(1)
	ST   X,R17
_0x1E:
	LDD  R26,Y+2
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	SUBI R30,LOW(1)
	LDD  R26,Y+3
	STD  Z+0,R26
_0x1F:
	RJMP _0x20
_0x1C:
	LDD  R30,Y+3
	ST   -Y,R30
	RCALL _putchar
_0x20:
	LDD  R17,Y+0
	ADIW R28,4
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
_0x21:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x23
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x27
	CPI  R18,37
	BRNE _0x28
	LDI  R17,LOW(1)
	RJMP _0x29
_0x28:
	RCALL SUBOPT_0x3
_0x29:
	RJMP _0x26
_0x27:
	CPI  R30,LOW(0x1)
	BRNE _0x2A
	CPI  R18,37
	BRNE _0x2B
	RCALL SUBOPT_0x3
	RJMP _0x7D
_0x2B:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2C
	LDI  R16,LOW(1)
	RJMP _0x26
_0x2C:
	CPI  R18,43
	BRNE _0x2D
	LDI  R20,LOW(43)
	RJMP _0x26
_0x2D:
	CPI  R18,32
	BRNE _0x2E
	LDI  R20,LOW(32)
	RJMP _0x26
_0x2E:
	RJMP _0x2F
_0x2A:
	CPI  R30,LOW(0x2)
	BRNE _0x30
_0x2F:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x31
	ORI  R16,LOW(128)
	RJMP _0x26
_0x31:
	RJMP _0x32
_0x30:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x26
_0x32:
	CPI  R18,48
	BRLO _0x35
	CPI  R18,58
	BRLO _0x36
_0x35:
	RJMP _0x34
_0x36:
	MOV  R26,R21
	LDI  R30,LOW(10)
	RCALL __MULB12U
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x26
_0x34:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x3A
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	RJMP _0x3B
_0x3A:
	CPI  R30,LOW(0x73)
	BRNE _0x3D
	RCALL SUBOPT_0x4
	STD  Y+6,R30
	ST   -Y,R30
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x3E
_0x3D:
	CPI  R30,LOW(0x70)
	BRNE _0x40
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x3E:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x41
_0x40:
	CPI  R30,LOW(0x64)
	BREQ _0x44
	CPI  R30,LOW(0x69)
	BRNE _0x45
_0x44:
	ORI  R16,LOW(4)
	RJMP _0x46
_0x45:
	CPI  R30,LOW(0x75)
	BRNE _0x47
_0x46:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	RCALL SUBOPT_0x7
	LDI  R17,LOW(5)
	RJMP _0x48
_0x47:
	CPI  R30,LOW(0x58)
	BRNE _0x4A
	ORI  R16,LOW(8)
	RJMP _0x4B
_0x4A:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x7C
_0x4B:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	RCALL SUBOPT_0x7
	LDI  R17,LOW(4)
_0x48:
	SBRS R16,2
	RJMP _0x4D
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x4E
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x8
	LDI  R20,LOW(45)
_0x4E:
	CPI  R20,0
	BREQ _0x4F
	SUBI R17,-LOW(1)
	RJMP _0x50
_0x4F:
	ANDI R16,LOW(251)
_0x50:
	RJMP _0x51
_0x4D:
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
_0x51:
_0x41:
	SBRC R16,0
	RJMP _0x52
_0x53:
	CP   R17,R21
	BRSH _0x55
	SBRS R16,7
	RJMP _0x56
	SBRS R16,2
	RJMP _0x57
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x58
_0x57:
	LDI  R18,LOW(48)
_0x58:
	RJMP _0x59
_0x56:
	LDI  R18,LOW(32)
_0x59:
	RCALL SUBOPT_0x3
	SUBI R21,LOW(1)
	RJMP _0x53
_0x55:
_0x52:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x5A
_0x5B:
	CPI  R19,0
	BREQ _0x5D
	SBRS R16,3
	RJMP _0x5E
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RCALL SUBOPT_0x7
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x7E
_0x5E:
	LDD  R26,Y+6
	LD   R30,X+
	STD  Y+6,R26
_0x7E:
	ST   -Y,R30
	RCALL SUBOPT_0x9
	CPI  R21,0
	BREQ _0x60
	SUBI R21,LOW(1)
_0x60:
	SUBI R19,LOW(1)
	RJMP _0x5B
_0x5D:
	RJMP _0x61
_0x5A:
_0x63:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x7
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x65:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x67
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x8
	RJMP _0x65
_0x67:
	CPI  R18,58
	BRLO _0x68
	SBRS R16,3
	RJMP _0x69
	SUBI R18,-LOW(7)
	RJMP _0x6A
_0x69:
	SUBI R18,-LOW(39)
_0x6A:
_0x68:
	SBRC R16,4
	RJMP _0x6C
	CPI  R18,49
	BRSH _0x6E
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x6D
_0x6E:
	RJMP _0x7F
_0x6D:
	CP   R21,R19
	BRLO _0x72
	SBRS R16,0
	RJMP _0x73
_0x72:
	RJMP _0x71
_0x73:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x74
	LDI  R18,LOW(48)
_0x7F:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x75
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x9
	CPI  R21,0
	BREQ _0x76
	SUBI R21,LOW(1)
_0x76:
_0x75:
_0x74:
_0x6C:
	RCALL SUBOPT_0x3
	CPI  R21,0
	BREQ _0x77
	SUBI R21,LOW(1)
_0x77:
_0x71:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x64
	RJMP _0x63
_0x64:
_0x61:
	SBRS R16,0
	RJMP _0x78
_0x79:
	CPI  R21,0
	BREQ _0x7B
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x5
	RJMP _0x79
_0x7B:
_0x78:
_0x7C:
_0x3B:
_0x7D:
	LDI  R17,LOW(0)
_0x26:
	RJMP _0x21
_0x23:
	RCALL __LOADLOCR6
	ADIW R28,17
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,1
	ST   -Y,R17
	MOV  R26,R28
	SUBI R26,LOW(2)
	ADD  R26,R15
	MOV  R17,R26
	LDI  R30,LOW(0)
	STD  Y+1,R30
	MOV  R26,R28
	SUBI R26,-(2)
	ADD  R26,R15
	RCALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	MOV  R30,R28
	SUBI R30,-(4)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL __print_G2
	LDD  R17,Y+0
	ADIW R28,2
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	OUT  0x18,R30
	OUT  0x17,R30
	OUT  0x12,R30
	OUT  0x11,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1:
	OUT  0x30,R30
	LDI  R30,LOW(0)
	OUT  0x33,R30
	OUT  0x32,R30
	OUT  0x36,R30
	OUT  0x3C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x3:
	ST   -Y,R18
	LDD  R30,Y+14
	ST   -Y,R30
	MOV  R30,R28
	SUBI R30,-(14)
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	LDD  R26,Y+14
	SUBI R26,LOW(4)
	STD  Y+14,R26
	SUBI R26,-LOW(4)
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	ST   -Y,R30
	LDD  R30,Y+14
	ST   -Y,R30
	MOV  R30,R28
	SUBI R30,-(14)
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x6:
	LDD  R26,Y+14
	SUBI R26,LOW(4)
	STD  Y+14,R26
	SUBI R26,-LOW(4)
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9:
	LDD  R30,Y+14
	ST   -Y,R30
	MOV  R30,R28
	SUBI R30,-(14)
	ST   -Y,R30
	RJMP __put_G2

_strlen:
	clr  r27
	ld   r26,y+
	clr  r30
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	inc  r30
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__MULB12U:
	MOV  R0,R26
	SUB  R26,R26
	LDI  R27,9
	RJMP __MULB12U1
__MULB12U3:
	BRCC __MULB12U2
	ADD  R26,R0
__MULB12U2:
	LSR  R26
__MULB12U1:
	ROR  R30
	DEC  R27
	BRNE __MULB12U3
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	DEC  R26
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
