// ========================== ATTINY2313V CPU ׽Ʈ α׷ =================
//  CPU : ATTINY2313V-12M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR
//      : serial 19200,N,8,1
//            I/O/TIMER0 ׽Ʈ
// ----------------------------------------------------------------------------
// ⺻ 
#include <tiny2313.h>						// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

//  
char com1_rx_data,com1_rx_eflg = 0;				//   ͷƮ  /÷

int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// Crystal Oscillator division factor: 1
        CLKPR=0x80;
        CLKPR=0x00;
// PortA 
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)

// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	TCCR0A=0x00;
	TCCR0B=0x00;
	TCNT0=0x00;
	OCR0A=0x00;
	OCR0B=0x00;

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	ICR1H=0x00;
	ICR1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
	GIMSK=0x00;
	MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK=0x00;

//  ʱȭ
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSRA=0x00;
	UCSRB=0x98;
	UCSRC=0x06;
	UBRRH=0x00;
	UBRRL=0x26;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
	USICR=0x00;

// Analog Comparator initialization
	ACSR=0x80;

// Global enable interrupts
#asm("sei")
}

// ================================  ͷƮ =============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [USART_RXC] void uart_rx_isr(void)
{
char status,data;

	status=UCSRA;
	data=UDR;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

}

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 12,000,000 / 1024 / 117 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
	TCNT0 = 138;						// 255-117 = 138
	timer0_cnt++;						// Ÿ̸0 ī
}

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void cpu_ioport_output(void);					// CPU PORT I/O ׽Ʈ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
void main(void)
{
	cpu_setup();						// cpuʱȭ
	main_menu_disp();					//  ޴ ǥ
	while(1){						// Place your code here
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
}

// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("=================== MAIN MENU ==================\r\n");
	printf("- 1  : CPU I/O PORT TEST                        \r\n");
	printf("----------------- CPUPLAZA ---------------------\r\n");
}

// ============================= IO PORT TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void cpu_ioport_output(void)
{
int out_cnt,exit_flg = 0;

	printf("================ CPU I/O PORT TEST ==============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("-------------------------------------------------\r\n");
// CPU PORT   
// PORTB[0..7] : OUT
	PORTB=0xff;						// Ʈ  reg
	DDRB=0xff;						// Ʈ  reg(0Է,1)
// PORTD[0..7] : OUT
	PORTD=0xfc;						// Ʈ  reg
	DDRD=0xfc;						// Ʈ  reg(0Է,1)

// LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
	TCCR0A=0x00;
	TCCR0B = 0x05;						// system clock,16,000,000 / 1024 = 11.719Khz
	TCNT0 = 138;						// 255-156 = 99
	OCR0A=0x00;
	OCR0B=0x00;
	TIMSK |= 0x02;						// TIMER0 ͷƮ 㰡

	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	out_cnt = 0;
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 50){				// 500ms  
			if(out_cnt >= 0 && out_cnt <= 7) PORTB = ~(1 << out_cnt);// PORTB (ش Ʈ 0)
			else if(out_cnt >= 8 && out_cnt <= 11){	// PORTD 
				if(out_cnt == 8) PORTB = 0xff;	// PORTB CLEAR
				PORTD = ~(4 << (out_cnt-8));	// PORTD (ش Ʈ 0)
			}
			out_cnt++;				//  ġ ī 
			if(out_cnt >= 15) out_cnt = 0;		//  ġ ʰ ˻
			if(out_cnt == 0){			//  ü ʱȭ
				PORTB = 0xff;
				PORTD = 0xff;
			}
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0A=0x00;
	TCCR0B = 0x00;						// system clock,16,000,000 / 1024 = 11.719Khz
	TCNT0 = 0;						// 255-156 = 99
	OCR0A=0x00;
	OCR0B=0x00;
	TIMSK &= 0xfd;						// TIMER0 ͷƮ 

// CPU PORT ʱⰪ  
// PORTB
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)
// PORTD
	PORTD=0x00;						// Ʈ  reg
	DDRD=0x00;						// Ʈ  reg(0Է,1)

	main_menu_disp();					//  ޴ ǥ
}

