// ========================== ATTINY2313V CPU ׽Ʈ α׷ =================
//  CPU : ATTINY2313V-12M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR
//      : serial 19200,N,8,1
//            PCINT0-7 ͷƮ ׽Ʈ
// ----------------------------------------------------------------------------
// ⺻ 
#include <tiny2313.h>						// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

//  
char com1_rx_data,com1_rx_eflg = 0;				//   ͷƮ  /÷

int exint_pc_flg = 0;						// PORT CHANGE ͷƮ  ÷
unsigned char exint_pc_pinb = 0;				// PCͷƮ PORTB  

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// Crystal Oscillator division factor: 1
        CLKPR=0x80;
        CLKPR=0x00;
// PortA 
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)

// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	TCCR0A=0x00;
	TCCR0B=0x00;
	TCNT0=0x00;
	OCR0A=0x00;
	OCR0B=0x00;

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	ICR1H=0x00;
	ICR1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
	GIMSK=0x00;
	MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK=0x00;

//  ʱȭ
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSRA=0x00;
	UCSRB=0x98;
	UCSRC=0x06;
	UBRRH=0x00;
	UBRRL=0x26;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
	USICR=0x00;

// Analog Comparator initialization
	ACSR=0x80;

// Global enable interrupts
#asm("sei")
}

// ================================  ͷƮ =============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [USART_RXC] void uart_rx_isr(void)
{
char status,data;

	status=UCSRA;
	data=UDR;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

}

// ======================= PORTB(PCINT0-7) ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [PCINT] void pin_change_isr0(void)
{
	exint_pc_flg = 1;					// PORT CHANGE ͷƮ
	exint_pc_pinb = PINB;					// PORTB  
}

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void exint_pc_test(void);					// PCINT0-7 TEST

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
void main(void)
{
	cpu_setup();						// cpuʱȭ
	main_menu_disp();					//  ޴ ǥ
	while(1){						// Place your code here
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '1') exint_pc_test();// PCINT0-7 TEST
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
}

// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("=================== MAIN MENU ==================\r\n");
	printf("- 1  : PCINT0-7 TEST                            \r\n");
	printf("----------------- CPUPLAZA ---------------------\r\n");
}

// ========================== PORT CHANGE INT TEST ============================
// [μ]: void
// ----------------------------------------------------------------------------
void exint_pc_test(void)
{
int exit_flg = 0;

	printf("============== PCINT0-7 TEST ==========\r\n");
	printf("- 0  : TOP menu                        \r\n");
	printf("- interrupt : PCINT0-7 Change Interrupt\r\n");
	printf("---------------------------------------\r\n");

// PCINT0-7 ͷƮ 
	GIMSK = 0x20;
	MCUCR = 0x00;
	PCMSK = 0xFF;
	EIFR = 0x20;

	PORTB = 0xff;						// ƮB Ǯ

	exint_pc_flg = 0;			        	// PCINT0-7 ͷƮ ÷ Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(exint_pc_flg){				// PCINT0-7 ͷƮ ÷ üũ
			printf("PC Interrupt > %02x\r\n",exint_pc_pinb);
			exint_pc_flg = 0;
		}
	}

// External Interrupt(s) 
	GIMSK &= 0xdf;
	MCUCR = 0x00;
	EIFR  = 0x00;
	PCMSK = 0x00;

	PORTB = 0x00;						// ƮB ʱġ

	main_menu_disp();					//  ޴ ǥ
}
